//+------------------------------------------------------------------+
//|                                                        obvBB.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Yellow

extern int bbPeriod = 2;
extern int bbDeviation = 0;

double gadblOBV[];
double obvBB[];

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer( 0, gadblOBV );
   SetIndexStyle( 0, DRAW_LINE );
   SetIndexBuffer(1, obvBB);
   SetIndexStyle( 1, DRAW_LINE );
   IndicatorDigits( 0 );     
   IndicatorShortName( "obvBB" );
   SetIndexLabel( 0, "obvBB" );
   return( 0 );
}

int start()
{
   int intCountedBars = IndicatorCounted();
   if ( intCountedBars > 0 ) intCountedBars--;
   
   int intLimit = Bars - intCountedBars - 1;
   
   for( int inx = intLimit; inx >=0; inx-- )
   {
      if ( inx == ( Bars - 1 ) )
      {
         gadblOBV[inx] = Volume[inx];
      }
      else 
      {
         if ( ( High[inx] == Low[inx] ) || ( Open[inx] == Close[inx] ) || ( Close[inx] == Close[inx+1] ) )
         {
            gadblOBV[inx] = gadblOBV[inx+1];
         }
         else
         {            
            if ( Close[inx] > Open[inx] )   gadblOBV[inx] = gadblOBV[inx+1] + ( Volume[inx] * ( Close[inx] - Open[inx] ) / ( High[inx] - Low[inx] ) );
            else                            gadblOBV[inx] = gadblOBV[inx+1] - ( Volume[inx] * ( Open[inx] - Close[inx] ) / ( High[inx] - Low[inx] ) );
         }
      }
      
   //added Bollinger Bands onPrevious data
   obvBB[inx] = iBands(NULL,0,bbPeriod,bbDeviation,gadblOBV,PRICE_LOW,MODE_LOWER,inx);
           
   }
   
   return( 0 );
}

